#include "scnhacking.h"

void dbg(char *format, ...) {
#ifdef EBUG
  va_list args;

  va_start(args, format);
  vfprintf(error, format, args);
  va_end(args);
#endif
}

/* error groks errno */
void error_dbg(char *format, ...) {
  va_list args;
  size_t len;

  va_start(args, format);
  vfprintf(error, format, args);
  va_end(args);

  len = strlen(format);
  if (*(format + len - 1) != '\n') fprintf(error, ": %s\n", strerror(errno));
}

void INFO(char *format, ...) {
  va_list args;

  if (verbose || debug) {
    va_start(args, format);
    vfprintf(stdout, format, args);
    va_end(args);
  }
}

void SAY(char *format, ...) {
  va_list args;

  if (! quiet) {
    va_start(args, format);
    vfprintf(stdout, format, args);
    va_end(args);
  }
}
