#ifndef DEBUG_H
#define DEBUG_H
#include <stdio.h>

void dbg(char *, ...);
void error_dbg(char *, ...);
void INFO(char *, ...);
void SAY(char *, ...);

extern int debug, quiet, verbose;
extern FILE *error;
extern char buffer[];

#ifdef _MSC_VER
/* Visual C++ */
#define DEBUG if (debug) dbg("DEBUG: "), dbg
#define TRACE if (debug && verbose) dbg("TRACE: "), dbg
#define TRACE1 if (debug && verbose > 1) dbg("  MEM: "), dbg
#define TRACE2 if (debug && verbose > 2) dbg("  MEM: "), dbg
#define ERROR dbg("ERROR: "), error_dbg
#else
#define DEBUG if (debug) dbg("DEBUG: %s(): %s:%d: ", __FUNCTION__, __FILE__, __LINE__), dbg
#define TRACE if (debug && verbose) dbg("TRACE: %s(): %s:%d: ", __FUNCTION__, __FILE__, __LINE__), dbg
#define TRACE1 if (debug && verbose > 1) dbg("  MEM: %s(): %s:%d: ", __FUNCTION__, __FILE__, __LINE__), dbg
#define TRACE2 if (debug && verbose > 2) dbg("  MEM: %s(): %s:%d: ", __FUNCTION__, __FILE__, __LINE__), dbg
#define ERROR dbg("ERROR: %s(): %s:%d: ", __FUNCTION__, __FILE__, __LINE__), error_dbg
#endif
#define WARN dbg("WARNING: "), error_dbg

#endif
