#ifndef FILE_H
#define FILE_H
#include <stdio.h>
#include <sys/types.h>
#ifdef _MSC_VER
#include <ctype.h>
#define read_string sscanf
#endif

FILE *open_read(char *);
FILE *open_write(char *);
off_t get_file_position(FILE *);
int skip(FILE *, off_t);
size_t try_read(FILE *, void *, size_t);
int read_char(FILE *, char *);
int read_unsigned_char(FILE *, unsigned char *);
int read_uint16(FILE *, unsigned short *);
int read_uint32(FILE *, unsigned int *);
int read_float(FILE *, float *);
int read_arbitrary(FILE *, void *, unsigned int);
int read_line(FILE *, char *, size_t);
size_t try_write(FILE *, void *, size_t);
int write_char(FILE *, char *);
int write_unsigned_char(FILE *, unsigned char *);
int write_uint16(FILE *, unsigned short *);
int write_uint32(FILE *, unsigned int *);
int write_float(FILE *, float *);
int write_arbitrary(FILE *, void *, unsigned int);
int write_string(FILE *, char *, ...);
int invalid_windows_filename(unsigned char *, unsigned short);
int missing_file(char *, unsigned short);
void set_basename(char *, unsigned short, char **, unsigned short *);
void ignore_comments(char *);
int null_line(char *);
#ifndef _MSC_VER
int read_string(char *, char *, ...);
#endif

#endif

