#ifndef LIGHT_H
#define LIGHT_H
#include "data.h"

#define COLOUR "Color"

struct colour_replace_set {
  struct colour_replace_set *next;
  unsigned int first_light_id;
  unsigned int last_light_id;
  float red;
  float green;
  float blue;
};
typedef struct colour_replace_set colour_replace_set_t;

colour_replace_set_t *alloc_colour_replace_set(void);
void cleanup_colour_replace_sets(colour_replace_set_t *);
int add_to_colour_replace_set(colour_replace_set_t **, char *, char *, char *, char *);
int replace_colours(scn_t *);
int replace_colour(scn_t *, colour_replace_set_t *set);
int is_light(entity_t *);
int summarise_lights(scn_t *);
int describe_lights(scn_t *);
int count_lights(scn_t *);

#endif
