#include <errno.h>
#include <stdio.h>
#include <time.h>
#include <unistd.h>

#define BUFSIZE 4096

int main() {
  char buffer[BUFSIZE];
  char *s;
  FILE *out;
  time_t t;
  struct tm *tm;

  if (! getcwd(buffer, sizeof(buffer))) {
    exit(1);
    perror("can't get working directory");
  }
  for (s = buffer; *s; s++);
  for (s--; *s == '-' || *s == '.' || (*s >= '0' && *s <= '9'); s--);
  s++; s++;

  t = time(0);
  tm = localtime(&t);

  out = fopen("version.H", "w");
  if (! out) exit(2);
  fprintf(out, "#define VERSION \"%s\"\n", s);
  fprintf(out, "#define VERSION_DATE \"%04d-%02d-%02d\"\n", tm->tm_year + 1900, tm->tm_mon + 1, tm->tm_mday);
  if (fclose(out)) {
    perror("can't close file(!)");
    exit(3);
  }

  if (rename("version.H", "version.h")) {
    perror("can't relink version.h");
    exit(4);
  }

  exit(0);
}
