#ifndef SCN_H
#define SCN_H
#include "option.h"

#define SCN_MAGIC "\x4e\x43\x53\x4d\x0d\x01\0\0"
#define SCN_MAGIC_LENGTH 8

struct lightmaps {
  off_t offset;
  unsigned int num_lights; /* could be short */
  size_t length; /* data stream length */
  unsigned int **addresses; /* pointers to the entities which are lights */
};

struct thing {
  off_t offset;
  int num; /* could be short */
  size_t orig_length; /* data stream length */
  size_t length; /* data stream length */
  void **things;
};
typedef struct thing thing_t;

struct scn {
  char *filename;
  char *basename;
  char *outfile;
  char *out_basename;
  char *tmpfile;
  struct option *option;
  unsigned short basename_length;
  unsigned short out_basename_length;
  FILE *fd;
  FILE *out_fd;
  char magic[8];
  unsigned short filename_length;
  struct lightmaps lightmaps; /* FIXME: use thing */
  struct thing entities;
  unsigned int num_entclasses;
  struct entclass **entclasses; /* how many of each entity */
};
typedef struct scn scn_t;

scn_t **alloc_scns(unsigned int);
scn_t *alloc_scn(void);
void cleanup_scn(scn_t *);
int read_scn_file(scn_t *);
int check_scn_magic(scn_t *);
int parse_scn(scn_t *);
int write_scn_file(scn_t *);
int open_scn_file(scn_t *);
int link_scn_file(scn_t *);
int close_scn_file(scn_t *);
int write_scn_data(scn_t *);
int write_scn_header(scn_t *);
int summarise_scn(scn_t *);
int describe_scn(scn_t *);

#endif
